#property script_show_inputs

#include <Codebase\nicholishen\Double.mqh>

input int LoopCount = 100;

void OnStart()
{
   ulong iterations = (ulong)pow(10,8);
  
   MqlTick tick;
   SymbolInfoTick(_Symbol,tick); 
   double price[3];
   price[0] = tick.bid;
   price[1] = tick.ask;
   price[2] = tick.ask + 1.0*_Point;
   srand(_RandomSeed);
   
   
   ///////////////////////////////////////////////////////////////////
   long result=0;
   ulong m = GetMicrosecondCount();
   for(ulong i=0;i<iterations;i++)
      result+= CompareDoubles1(price[0],price[1]);
        
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("1: %d ms for %d iterations",m,iterations);
   printf("result = %d",result);
   ///////////////////////////////////////////////////////////////////
   result=0;
   m = GetMicrosecondCount();
   for(ulong i=0;i<iterations;i++)
      result+= CompareDoubles2(price[0],price[1]);
        
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("2: %d ms for %d iterations",m,iterations);
   printf("result = %d",result);
   ///////////////////////////////////////////////////////////////////
   result=0;
   m = GetMicrosecondCount();
   for(ulong i=0;i<iterations;i++)
      result+= CompareDoubles3(price[0],price[1]);
        
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("3: %d ms for %d iterations",m,iterations);
   printf("result = %d",result);
   ///////////////////////////////////////////////////////////////////
   result=0;
   m = GetMicrosecondCount();
   for(ulong i=0;i<iterations;i++)
      result+= CompareDoubles4(price[0],price[1]);
        
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("4: %d ms for %d iterations",m,iterations);
   printf("result = %d",result);
   ///////////////////////////////////////////////////////////////////
   result=0;
   m = GetMicrosecondCount();
   for(ulong i=0;i<iterations;i++)
      result+= CompareDoubles5(price[0],price[1]);
        
   m=GetMicrosecondCount()-m;
   m/=1000;
   printf("5: %d ms for %d iterations",m,iterations);
   printf("result = %d",result);
}
//+------------------------------------------------------------------+

int CompareDoubles1(const double num1,const double num2)
{
   double res = NormalizeDouble(num1-num2,_Digits);
   double res2 = res;
   for( double j = LoopCount; j > 0; j-- )
      res2 += j;
   if(res==0.0)
      return 0;
   if(res > 0.0)
      return 1;
   return -1;
}

int CompareDoubles2(const double num1,const double num2)
{
   double res = num1-num2;
   double res2 = res;
   for( double j = LoopCount; j > 0; j-- )
      res2 += j;
   if(fabs(res) < _Point / 10.0 * 5)
      return 0;
   if(res > 0.0)
      return 1;
   return -1;
}

int CompareDoubles3(const double num1,const double num2)
{
   int res =  ((int)round(num1 / _Point) - (int)round(num2 / _Point));
   int res2 = res;
   for( int j = LoopCount; j > 0; j-- )
      res2 += j;
   if(res==0)
      return 0;
   if(res > 0)
      return 1;
   return -1;
}

int CompareDoubles4(const double num1,const double num2)
{
   long res =  ((long)round(num1 / _Point) - (long)round(num2 / _Point));
   long res2 = res;
   for( long j = LoopCount; j > 0; j-- )
      res2 += j;
   if(res==0)
      return 0;
   if(res > 0)
      return 1;
   return -1;
}

int CompareDoubles5(const double num1,const double num2)
{
   CDouble onum1=num1,onum2=num2;
   CDouble res = onum1-onum2;
   CDouble res2 = res;
   for( double j = LoopCount; j > 0; j-- )
      res2 += j;
   if(fabs(res.AsRawDouble()) < _Point / 10.0 * 5)
      return 0;
   if(res > 0.0)
      return 1;
   return -1;
}
